"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _reactNativeReanimated = _interopRequireWildcard(require("react-native-reanimated"));

var _styles = _interopRequireDefault(require("./styles"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const Y_DISTANCE = 120;

const AnimatedButton = _ref => {
  let {
    onPress = () => null,
    duration = 500,
    style = {},
    direction = 'up',
    children = null,
    renderFlyingContainer = () => null,
    enableScaleAnimation = true,
    position = 'center',
    animationEnabled = true
  } = _ref;
  const animatedValue = (0, _reactNativeReanimated.useSharedValue)(0);
  const getPosition = (0, _react.useCallback)(value => {
    switch (value) {
      case 'left':
        return 'flex-start';

      case 'center':
        return 'center';

      case 'right':
        return 'flex-end';

      default:
        return 'center';
    }
  }, []);
  const containerPosition = (0, _react.useMemo)(() => getPosition(position), [position]);
  const styleProps = (0, _react.useMemo)(() => ({
    position: containerPosition
  }), [containerPosition]);
  const yTranslation = (0, _react.useMemo)(() => direction == 'up' ? -Y_DISTANCE : Y_DISTANCE, [direction]);
  const rCStyle = (0, _reactNativeReanimated.useAnimatedStyle)(() => {
    if (!enableScaleAnimation) {
      return {};
    }

    return {
      transform: [{
        scale: (0, _reactNativeReanimated.interpolate)(animatedValue.value, [0, 0.5, 1], [1, 0.8, 1])
      }]
    };
  });
  const rChStyle = (0, _reactNativeReanimated.useAnimatedStyle)(() => {
    return {
      transform: [{
        translateY: (0, _reactNativeReanimated.interpolate)(animatedValue.value, [0, 0.9, 1], [0, yTranslation, 0])
      }],
      opacity: (0, _reactNativeReanimated.interpolate)(animatedValue.value, [0, 0.6, 0.8, 0.81, 1], [0, 1, 0.5, 0, 0])
    };
  });
  const handleOnPress = (0, _react.useCallback)(() => {
    if (animationEnabled) animatedValue.value = (0, _reactNativeReanimated.withTiming)(1, {
      duration
    }, isFinished => {
      if (isFinished) {
        animatedValue.value = 0;
      }
    });
    onPress === null || onPress === void 0 ? void 0 : onPress();
  }, [animationEnabled, duration, onPress]);
  return /*#__PURE__*/_react.default.createElement(_reactNative.View, null, /*#__PURE__*/_react.default.createElement(_reactNativeReanimated.default.View, {
    style: [rCStyle]
  }, /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
    style: style,
    activeOpacity: 0.8,
    onPress: handleOnPress
  }, children)), /*#__PURE__*/_react.default.createElement(_reactNativeReanimated.default.View, {
    pointerEvents: 'none',
    style: [(0, _styles.default)(styleProps).childContainer, rChStyle]
  }, (renderFlyingContainer === null || renderFlyingContainer === void 0 ? void 0 : renderFlyingContainer()) || children || /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: style
  })));
};

var _default = AnimatedButton;
exports.default = _default;
//# sourceMappingURL=index.js.map